#include <linux/config.h>
#include <linux/init.h>
#include <linux/sched.h>
#include <linux/kernel.h>
#include <linux/mm.h>
#include <linux/tty.h>
#include <linux/string.h>
#include <linux/adb.h>
#include <linux/cuda.h>
#include <linux/pmu.h>
#include <linux/suspend.h>
#include <linux/delay.h>
#include <linux/module.h>

#include <asm/mmu_context.h>

extern void enable_kernel_altivec(void);

static inline void do_pmu_resume(void)
{
	struct adb_request req;

	printk("resume pmu");	
	/* Tell PMU we are ready */
	pmu_request(&req, NULL, 2, PMU_SYSTEM_READY, 2);
	pmu_wait_complete(&req);

	/* Resume PMU event interrupts */
	pmu_resume();	
	printk(".\n");
}

void save_processor_state(void)
{
	printk("suspend pmu");	
	pmu_suspend();
	printk(".\n");
	printk("current is 0x%p\n", current);
}

void restore_processor_state(void)
{
	printk("seting context, 0x%p", current);
	local_irq_disable();
	/* Restore userland MMU context */
	set_context(current->active_mm->context, current->active_mm->pgd);
	printk(".\n");

#ifdef CONFIG_ALTIVEC
	if (cur_cpu_spec[0]->cpu_features & CPU_FTR_ALTIVEC)
		enable_kernel_altivec();
#endif
	printk("enable kernel fp");
	enable_kernel_fp();
	printk(".\n");
	do_pmu_resume();
	local_irq_enable();
}

EXPORT_SYMBOL(save_processor_state);
EXPORT_SYMBOL(restore_processor_state);
