/*
 * This code base on pmdisk.S by Benjamin Herrenschmidt <benh@kernel.crashing.org>
 *
 * changed for swsusp2 by Hu Gang <hugang@soulinfo.com>
 */
#include <linux/config.h>
#include <asm/processor.h>
#include <asm/page.h>
#include <asm/ppc_asm.h>
#include <asm/cputable.h>
#include <asm/cache.h>
#include <asm/thread_info.h>
#include <asm/offsets.h>
#include "cpu_reg.S"

	CPU_REG_MEM_DEFINE

	.section .text
	.align 5
_GLOBAL(do_suspend2_lowlevel)
	CPU_REG_STACK_SAVE
	cmpwi	0,r3,0
	bne	do_resume
	bl	save_processor_state
	bl	do_suspend2_suspend_1
	CPU_REG_MEM_SAVE
	bl	do_suspend2_suspend_2
	CPU_REG_MEM_RESTORE_END 
	CPU_REG_STACK_RESTORE
	
do_resume:
	bl save_processor_state
	bl do_suspend2_resume_1

	/* Stop pending alitvec streams and memory accesses */
BEGIN_FTR_SECTION
	DSSALL
END_FTR_SECTION_IFSET(CPU_FTR_ALTIVEC)
 	sync

	CPU_REG_MEM_DISABLE_MMU 
#include "swsusp2-copyback.S"
	CPU_REG_MEM_FLUSH_CACHE
	
	CPU_REG_MEM_RESTORE
	bl	do_suspend2_resume_2
	bl	restore_processor_state
	CPU_REG_MEM_RESTORE_END
	CPU_REG_STACK_RESTORE

	CPU_REG_TURN_ON_MMU

	.section .text
