 /*
  * Copyright 2003 Nigel Cunningham.
  *
  * This is the code that the code in swsusp2-asm.S for
  * copying back the original kernel is based upon. It
  * was based upon code that is...
  * Copyright 2001-2002 Pavel Machek <pavel@suse.cz>
  * Based on code
  * Copyright 2001 Patrick Mochel <mochel@osdl.org>
  * Copyright 2004 Hu Gang <hugang@soulinfo.com
  *  port to PowerPC
  */
#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/types.h>
#include <linux/spinlock.h>
#include <linux/poll.h>
#include <linux/delay.h>
#include <linux/sysrq.h>
#include <linux/proc_fs.h>
#include <linux/irq.h>
#include <linux/pm.h>
#include <linux/device.h>
#include <linux/suspend.h>
#include <linux/suspend-debug.h>
#include <linux/suspend-common.h>
#include <asm/uaccess.h>
#if 0
/* Local variables for do_swsusp2_suspend */
volatile static int state1 __nosavedata = 0;
volatile static int state2 __nosavedata = 0;
volatile static int state3 __nosavedata = 0;
volatile static int loop __nosavedata = 0;
volatile static struct range *origrange __nosavedata;
volatile static struct range *copyrange __nosavedata;
volatile static int origoffset __nosavedata;
volatile static int copyoffset __nosavedata;
volatile static unsigned long * origpage __nosavedata;
volatile static unsigned long * copypage __nosavedata;
#endif

//volatile static int orig_min_free __nosavedata;
#ifndef CONFIG_SMP
//static unsigned long c_loops_per_jiffy_ref __nosavedata = 0;
//static unsigned long cpu_khz_ref __nosavedata = 0;
#endif

extern void do_swsusp2_suspend_1(void);
extern void do_swsusp2_suspend_2(void);
extern void do_swsusp2_resume_1(void);
extern void do_swsusp2_resume_2(void);
extern struct pagedir __nosavedata pagedir_resume;

/*
 * FIXME: This function should really be written in assembly. Actually
 * requirement is that it does not touch stack, because %esp will be
 * wrong during resume before restore_processor_context(). Check
 * assembly if you modify this.
 */
#if 0
static inline void pre_copyback(void)
{
#ifdef CONFIG_PREEMPT
	/*
	 * Preempt disabled in kernel we're about to restore.
	 * Make sure we match state now.
	 */
	preempt_disable();
	PRINTPREEMPTCOUNT("Prior to copying old kernel back.");
#endif

	state1 = swsusp_action;
	state2 = swsusp_debug_state;
	state3 = console_loglevel;

#ifndef CONFIG_SMP
	//c_loops_per_jiffy_ref = cpu_data->loops_per_jiffy;
	//cpu_khz_ref = cpu_khz;
#endif
}
static inline void post_copyback(void)
{
#ifndef CONFIG_SMP
	//cpu_data->loops_per_jiffy = c_loops_per_jiffy_ref;
	//loops_per_jiffy = c_loops_per_jiffy_ref;
	//cpu_khz = cpu_khz_ref;
#endif
	swsusp_action = state1;
	swsusp_debug_state = state2;
	console_loglevel = state3;
	//swsusp_min_free = orig_min_free;

}
#endif
static inline void do_swsusp2_copyback(void)
{
	/* PowerPC has a lots register, use local register is possible */
	register int origoffset, copyoffset;
	register unsigned long * origpage, * copypage;
	register struct range *origrange, *copyrange;
//	register int pagesize;

//	pre_copyback();

	origrange = pagedir_resume.origranges.first;
//	pagesize = pagedir_resume.pageset_size;
//	printk("%d\n", pagesize);
	origoffset = origrange->minimum;
	origpage = (unsigned long *) (page_address(mem_map + origoffset));
	
	copyrange = pagedir_resume.destranges.first;
	copyoffset = copyrange->minimum;
	copypage = (unsigned long *) (page_address(mem_map + copyoffset));
	//orig_min_free = swsusp_min_free;

	while (origrange) {
		register int loop;
		for (loop = 0; loop < (PAGE_SIZE / sizeof(unsigned long)); loop++)
			*(origpage + loop) = *(copypage + loop);
		
		if (origoffset < origrange->maximum) {
			origoffset++;
			origpage += (PAGE_SIZE / sizeof(unsigned long));
		} else {
			origrange = origrange->next;
			if (origrange) {
				origoffset = origrange->minimum;
				origpage = (unsigned long *) (page_address(mem_map + origoffset));
			}
		}

		if (copyoffset < copyrange->maximum) {
			copyoffset++;
			copypage += (PAGE_SIZE / sizeof(unsigned long));
		} else {
			copyrange = copyrange->next;
			if (copyrange) {
				copyoffset = copyrange->minimum;
				copypage = (unsigned long *) (page_address(mem_map + copyoffset));
			}
		}
	}
	
/* Ahah, we now run with our old stack, and with registers copied from
   suspend time */

//	post_copyback();
}

void do_swsusp_lowlevel(int resume)
{
	if (!resume) {
		do_swsusp2_suspend_1();
		save_processor_state();
		/* saving stack */
		
		do_swsusp2_suspend_2();
		return;
	}

	/* setup swapper_pg_dir in x86 */

	do_swsusp2_resume_1();
	do_swsusp2_copyback();
	/* setup segment register */
	restore_processor_state();
	do_swsusp2_resume_2();
}
